rem ---------------------------------------------------------------------------
rem  Trivadis AG, Baden-Dttwil/Basel/Bern/Lausanne/Zrich
rem               Dsseldorf/Frankfurt/Freiburg i.Br./Hamburg/Mnchen/Stuttgart
rem               Wien
rem               Switzerland/Germany/Austria Internet: http://www.trivadis.com
rem ---------------------------------------------------------------------------
rem ***************************************************************************
rem ****** sample script for course/seminar New Features 11g Release 1)  ******
rem ***************************************************************************
rem  Group/Privileges.: User
rem  Script-Name......: ex_virtual_column_pruning.sql
rem  Developer........: Christian Antognini (christian.antognini@trivadis.com)
rem  Date.............: November 2007
rem  Version..........: Oracle Database 11g Release 1 - 11.1
rem  Description......: This script shows that partition pruning works for both
rem                     the virtual column and the function defining it.
rem  Usage............: 
rem                     
rem  Input parameters.: 
rem  Output...........: 
rem  Called by........:
rem  Requirements.....: 
rem  Remarks..........: 
rem
rem ---------------------------------------------------------------------------
rem Changes:
rem DD.MM.YYYY Developer Change
rem ---------------------------------------------------------------------------
rem
rem ---------------------------------------------------------------------------

SET ECHO ON TERMOUT ON SERVEROUTPUT OFF FEEDBACK OFF PAGESIZE 100 LINESIZE 80

DROP TABLE t PURGE;

CLEAR SCREEN

REM
REM create test table, insert data and gather statistics
REM

CREATE TABLE t (
  id NUMBER,
  pkey AS (mod(id,4)),
  pad VARCHAR2(100)
)
PARTITION BY LIST (pkey)
(
  PARTITION t_0 VALUES (0),
  PARTITION t_1 VALUES (1),
  PARTITION t_2 VALUES (2),
  PARTITION t_3 VALUES (3)
);

PAUSE

INSERT INTO t (id, pad) 
SELECT rownum, rpad('*',50,'*')
FROM all_objects
WHERE rownum <= 1000;

execute dbms_stats.gather_table_stats(user,'t')

PAUSE

REM
REM partition pruning with a restriction based on the virtual column
REM

EXPLAIN PLAN FOR SELECT * FROM t WHERE pkey = 1;

SELECT * FROM table(dbms_xplan.display(NULL, NULL, 'basic partition'));

PAUSE

REM
REM partition pruning with a restriction based on the function
REM defining the virtual column
REM

EXPLAIN PLAN FOR SELECT * FROM t WHERE mod(id,4) = 1;

SELECT * FROM table(dbms_xplan.display(NULL, NULL, 'basic partition'));

SET ECHO OFF
